/*
 * THIS FILE WAS AUTOMATICALLY GENERATED, DO NOT EDIT.
 *
 * Copyright (C) 2017 Apple Inc. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY APPLE INC. AND ITS CONTRIBUTORS ``AS IS''
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL APPLE INC. OR ITS CONTRIBUTORS
 * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 * THE POSSIBILITY OF SUCH DAMAGE.
 */

#include "config.h"
#include "WebPreferences.h"

#include "WebPreferencesKeys.h"

namespace WebKit {

void WebPreferences::setPageAtRuleSupportEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::pageAtRuleSupportEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::pageAtRuleSupportEnabledKey(), value);
}

bool WebPreferences::pageAtRuleSupportEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::pageAtRuleSupportEnabledKey());
}

void WebPreferences::setAccessibilityObjectModelEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::accessibilityObjectModelEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::accessibilityObjectModelEnabledKey(), value);
}

bool WebPreferences::accessibilityObjectModelEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::accessibilityObjectModelEnabledKey());
}

void WebPreferences::setAdClickAttributionDebugModeEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::adClickAttributionDebugModeEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::adClickAttributionDebugModeEnabledKey(), value);
}

bool WebPreferences::adClickAttributionDebugModeEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::adClickAttributionDebugModeEnabledKey());
}

void WebPreferences::setAdClickAttributionEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::adClickAttributionEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::adClickAttributionEnabledKey(), value);
}

bool WebPreferences::adClickAttributionEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::adClickAttributionEnabledKey());
}

void WebPreferences::setAspectRatioOfImgFromWidthAndHeightEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::aspectRatioOfImgFromWidthAndHeightEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::aspectRatioOfImgFromWidthAndHeightEnabledKey(), value);
}

bool WebPreferences::aspectRatioOfImgFromWidthAndHeightEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::aspectRatioOfImgFromWidthAndHeightEnabledKey());
}

void WebPreferences::setAsyncClipboardAPIEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::asyncClipboardAPIEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::asyncClipboardAPIEnabledKey(), value);
}

bool WebPreferences::asyncClipboardAPIEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::asyncClipboardAPIEnabledKey());
}

void WebPreferences::setHTTPSUpgradeEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::httpSUpgradeEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::httpSUpgradeEnabledKey(), value);
}

bool WebPreferences::httpSUpgradeEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::httpSUpgradeEnabledKey());
}

void WebPreferences::setBlankAnchorTargetImpliesNoOpenerEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::blankAnchorTargetImpliesNoOpenerEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::blankAnchorTargetImpliesNoOpenerEnabledKey(), value);
}

bool WebPreferences::blankAnchorTargetImpliesNoOpenerEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::blankAnchorTargetImpliesNoOpenerEnabledKey());
}

void WebPreferences::setThirdPartyIframeRedirectBlockingEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::thirdPartyIframeRedirectBlockingEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::thirdPartyIframeRedirectBlockingEnabledKey(), value);
}

bool WebPreferences::thirdPartyIframeRedirectBlockingEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::thirdPartyIframeRedirectBlockingEnabledKey());
}

void WebPreferences::setWebAnimationsCSSIntegrationEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::webAnimationsCSSIntegrationEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::webAnimationsCSSIntegrationEnabledKey(), value);
}

bool WebPreferences::webAnimationsCSSIntegrationEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::webAnimationsCSSIntegrationEnabledKey());
}

void WebPreferences::setCSSCustomPropertiesAndValuesEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::cssCustomPropertiesAndValuesEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::cssCustomPropertiesAndValuesEnabledKey(), value);
}

bool WebPreferences::cssCustomPropertiesAndValuesEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::cssCustomPropertiesAndValuesEnabledKey());
}

void WebPreferences::setCSSPaintingAPIEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::cssPaintingAPIEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::cssPaintingAPIEnabledKey(), value);
}

bool WebPreferences::cssPaintingAPIEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::cssPaintingAPIEnabledKey());
}

void WebPreferences::setCSSShadowPartsEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::cssShadowPartsEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::cssShadowPartsEnabledKey(), value);
}

bool WebPreferences::cssShadowPartsEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::cssShadowPartsEnabledKey());
}

void WebPreferences::setSpringTimingFunctionEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::springTimingFunctionEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::springTimingFunctionEnabledKey(), value);
}

bool WebPreferences::springTimingFunctionEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::springTimingFunctionEnabledKey());
}

void WebPreferences::setCSSTypedOMEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::cssTypedOMEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::cssTypedOMEnabledKey(), value);
}

bool WebPreferences::cssTypedOMEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::cssTypedOMEnabledKey());
}

void WebPreferences::setCSSOMViewSmoothScrollingEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::cssOMViewSmoothScrollingEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::cssOMViewSmoothScrollingEnabledKey(), value);
}

bool WebPreferences::cssOMViewSmoothScrollingEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::cssOMViewSmoothScrollingEnabledKey());
}

void WebPreferences::setCaptureVideoInUIProcessEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::captureVideoInUIProcessEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::captureVideoInUIProcessEnabledKey(), value);
}

bool WebPreferences::captureVideoInUIProcessEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::captureVideoInUIProcessEnabledKey());
}

void WebPreferences::setCoreImageAcceleratedFilterRenderEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::coreImageAcceleratedFilterRenderEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::coreImageAcceleratedFilterRenderEnabledKey(), value);
}

bool WebPreferences::coreImageAcceleratedFilterRenderEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::coreImageAcceleratedFilterRenderEnabledKey());
}

void WebPreferences::setShouldDeferAsynchronousScriptsUntilAfterDocumentLoadOrFirstPaint(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::shouldDeferAsynchronousScriptsUntilAfterDocumentLoadOrFirstPaintKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::shouldDeferAsynchronousScriptsUntilAfterDocumentLoadOrFirstPaintKey(), value);
}

bool WebPreferences::shouldDeferAsynchronousScriptsUntilAfterDocumentLoadOrFirstPaint() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::shouldDeferAsynchronousScriptsUntilAfterDocumentLoadOrFirstPaintKey());
}

void WebPreferences::setDialogElementEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::dialogElementEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::dialogElementEnabledKey(), value);
}

bool WebPreferences::dialogElementEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::dialogElementEnabledKey());
}

void WebPreferences::setIsThirdPartyCookieBlockingDisabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::isThirdPartyCookieBlockingDisabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::isThirdPartyCookieBlockingDisabledKey(), value);
}

bool WebPreferences::isThirdPartyCookieBlockingDisabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::isThirdPartyCookieBlockingDisabledKey());
}

void WebPreferences::setIsFirstPartyWebsiteDataRemovalDisabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::isFirstPartyWebsiteDataRemovalDisabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::isFirstPartyWebsiteDataRemovalDisabledKey(), value);
}

bool WebPreferences::isFirstPartyWebsiteDataRemovalDisabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::isFirstPartyWebsiteDataRemovalDisabledKey());
}

void WebPreferences::setWebSQLDisabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::webSQLDisabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::webSQLDisabledKey(), value);
}

bool WebPreferences::webSQLDisabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::webSQLDisabledKey());
}

void WebPreferences::setDisallowSyncXHRDuringPageDismissalEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::disallowSyncXHRDuringPageDismissalEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::disallowSyncXHRDuringPageDismissalEnabledKey(), value);
}

bool WebPreferences::disallowSyncXHRDuringPageDismissalEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::disallowSyncXHRDuringPageDismissalEnabledKey());
}

void WebPreferences::setFetchAPIKeepAliveEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::fetchAPIKeepAliveEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::fetchAPIKeepAliveEnabledKey(), value);
}

bool WebPreferences::fetchAPIKeepAliveEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::fetchAPIKeepAliveEnabledKey());
}

void WebPreferences::setGenericCueAPIEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::genericCueAPIEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::genericCueAPIEnabledKey(), value);
}

bool WebPreferences::genericCueAPIEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::genericCueAPIEnabledKey());
}

void WebPreferences::setHDRMediaCapabilitiesEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::hDRMediaCapabilitiesEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::hDRMediaCapabilitiesEnabledKey(), value);
}

bool WebPreferences::hDRMediaCapabilitiesEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::hDRMediaCapabilitiesEnabledKey());
}

void WebPreferences::setHTTP3Enabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::http3EnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::http3EnabledKey(), value);
}

bool WebPreferences::http3Enabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::http3EnabledKey());
}

void WebPreferences::setHighlightAPIEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::highlightAPIEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::highlightAPIEnabledKey(), value);
}

bool WebPreferences::highlightAPIEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::highlightAPIEnabledKey());
}

void WebPreferences::setImageBitmapEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::imageBitmapEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::imageBitmapEnabledKey(), value);
}

bool WebPreferences::imageBitmapEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::imageBitmapEnabledKey());
}

void WebPreferences::setInProcessCookieCacheEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::inProcessCookieCacheEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::inProcessCookieCacheEnabledKey(), value);
}

bool WebPreferences::inProcessCookieCacheEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::inProcessCookieCacheEnabledKey());
}

void WebPreferences::setIncrementalPDFLoadingEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::incrementalPDFLoadingEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::incrementalPDFLoadingEnabledKey(), value);
}

bool WebPreferences::incrementalPDFLoadingEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::incrementalPDFLoadingEnabledKey());
}

void WebPreferences::setIntersectionObserverEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::intersectionObserverEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::intersectionObserverEnabledKey(), value);
}

bool WebPreferences::intersectionObserverEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::intersectionObserverEnabledKey());
}

void WebPreferences::setIsLoggedInAPIEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::isLoggedInAPIEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::isLoggedInAPIEnabledKey(), value);
}

bool WebPreferences::isLoggedInAPIEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::isLoggedInAPIEnabledKey());
}

void WebPreferences::setIsAccessibilityIsolatedTreeEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::isAccessibilityIsolatedTreeEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::isAccessibilityIsolatedTreeEnabledKey(), value);
}

bool WebPreferences::isAccessibilityIsolatedTreeEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::isAccessibilityIsolatedTreeEnabledKey());
}

void WebPreferences::setLazyImageLoadingEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::lazyImageLoadingEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::lazyImageLoadingEnabledKey(), value);
}

bool WebPreferences::lazyImageLoadingEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::lazyImageLoadingEnabledKey());
}

void WebPreferences::setLinkPreloadResponsiveImagesEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::linkPreloadResponsiveImagesEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::linkPreloadResponsiveImagesEnabledKey(), value);
}

bool WebPreferences::linkPreloadResponsiveImagesEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::linkPreloadResponsiveImagesEnabledKey());
}

void WebPreferences::setLinkPrefetchEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::linkPrefetchEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::linkPrefetchEnabledKey(), value);
}

bool WebPreferences::linkPrefetchEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::linkPrefetchEnabledKey());
}

void WebPreferences::setMaskWebGLStringsEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::maskWebGLStringsEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::maskWebGLStringsEnabledKey(), value);
}

bool WebPreferences::maskWebGLStringsEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::maskWebGLStringsEnabledKey());
}

void WebPreferences::setCoreMathMLEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::coreMathMLEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::coreMathMLEnabledKey(), value);
}

bool WebPreferences::coreMathMLEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::coreMathMLEnabledKey());
}

void WebPreferences::setMediaCapabilitiesExtensionsEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::mediaCapabilitiesExtensionsEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::mediaCapabilitiesExtensionsEnabledKey(), value);
}

bool WebPreferences::mediaCapabilitiesExtensionsEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::mediaCapabilitiesExtensionsEnabledKey());
}

void WebPreferences::setMediaRecorderEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::mediaRecorderEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::mediaRecorderEnabledKey(), value);
}

bool WebPreferences::mediaRecorderEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::mediaRecorderEnabledKey());
}

void WebPreferences::setModernUnprefixedWebAudioEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::modernUnprefixedWebAudioEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::modernUnprefixedWebAudioEnabledKey(), value);
}

bool WebPreferences::modernUnprefixedWebAudioEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::modernUnprefixedWebAudioEnabledKey());
}

void WebPreferences::setIsNSURLSessionWebSocketEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::isNSURLSessionWebSocketEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::isNSURLSessionWebSocketEnabledKey(), value);
}

bool WebPreferences::isNSURLSessionWebSocketEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::isNSURLSessionWebSocketEnabledKey());
}

void WebPreferences::setPaintTimingEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::paintTimingEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::paintTimingEnabledKey(), value);
}

bool WebPreferences::paintTimingEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::paintTimingEnabledKey());
}

void WebPreferences::setGoogleAntiFlickerOptimizationQuirkEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::googleAntiFlickerOptimizationQuirkEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::googleAntiFlickerOptimizationQuirkEnabledKey(), value);
}

bool WebPreferences::googleAntiFlickerOptimizationQuirkEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::googleAntiFlickerOptimizationQuirkEnabledKey());
}

void WebPreferences::setReadableByteStreamAPIEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::readableByteStreamAPIEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::readableByteStreamAPIEnabledKey(), value);
}

bool WebPreferences::readableByteStreamAPIEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::readableByteStreamAPIEnabledKey());
}

void WebPreferences::setReferrerPolicyAttributeEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::referrerPolicyAttributeEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::referrerPolicyAttributeEnabledKey(), value);
}

bool WebPreferences::referrerPolicyAttributeEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::referrerPolicyAttributeEnabledKey());
}

void WebPreferences::setRemotePlaybackEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::remotePlaybackEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::remotePlaybackEnabledKey(), value);
}

bool WebPreferences::remotePlaybackEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::remotePlaybackEnabledKey());
}

void WebPreferences::setResizeObserverEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::resizeObserverEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::resizeObserverEnabledKey(), value);
}

bool WebPreferences::resizeObserverEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::resizeObserverEnabledKey());
}

void WebPreferences::setIsSameSiteStrictEnforcementEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::isSameSiteStrictEnforcementEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::isSameSiteStrictEnforcementEnabledKey(), value);
}

bool WebPreferences::isSameSiteStrictEnforcementEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::isSameSiteStrictEnforcementEnabledKey());
}

void WebPreferences::setScreenCaptureEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::screenCaptureEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::screenCaptureEnabledKey(), value);
}

bool WebPreferences::screenCaptureEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::screenCaptureEnabledKey());
}

void WebPreferences::setServerTimingEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::serverTimingEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::serverTimingEnabledKey(), value);
}

bool WebPreferences::serverTimingEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::serverTimingEnabledKey());
}

void WebPreferences::setProcessSwapOnCrossSiteNavigationEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::processSwapOnCrossSiteNavigationEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::processSwapOnCrossSiteNavigationEnabledKey(), value);
}

bool WebPreferences::processSwapOnCrossSiteNavigationEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::processSwapOnCrossSiteNavigationEnabledKey());
}

void WebPreferences::setSyntheticEditingCommandsEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::syntheticEditingCommandsEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::syntheticEditingCommandsEnabledKey(), value);
}

bool WebPreferences::syntheticEditingCommandsEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::syntheticEditingCommandsEnabledKey());
}

void WebPreferences::setVP9DecoderEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::vp9DecoderEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::vp9DecoderEnabledKey(), value);
}

bool WebPreferences::vp9DecoderEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::vp9DecoderEnabledKey());
}

void WebPreferences::setVisualViewportAPIEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::visualViewportAPIEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::visualViewportAPIEnabledKey(), value);
}

bool WebPreferences::visualViewportAPIEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::visualViewportAPIEnabledKey());
}

void WebPreferences::setWebAnimationsCompositeOperationsEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::webAnimationsCompositeOperationsEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::webAnimationsCompositeOperationsEnabledKey(), value);
}

bool WebPreferences::webAnimationsCompositeOperationsEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::webAnimationsCompositeOperationsEnabledKey());
}

void WebPreferences::setWebAnimationsMutableTimelinesEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::webAnimationsMutableTimelinesEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::webAnimationsMutableTimelinesEnabledKey(), value);
}

bool WebPreferences::webAnimationsMutableTimelinesEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::webAnimationsMutableTimelinesEnabledKey());
}

void WebPreferences::setWebAnimationsEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::webAnimationsEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::webAnimationsEnabledKey(), value);
}

bool WebPreferences::webAnimationsEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::webAnimationsEnabledKey());
}

void WebPreferences::setWebAuthenticationLocalAuthenticatorEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::webAuthenticationLocalAuthenticatorEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::webAuthenticationLocalAuthenticatorEnabledKey(), value);
}

bool WebPreferences::webAuthenticationLocalAuthenticatorEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::webAuthenticationLocalAuthenticatorEnabledKey());
}

void WebPreferences::setWebAuthenticationEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::webAuthenticationEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::webAuthenticationEnabledKey(), value);
}

bool WebPreferences::webAuthenticationEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::webAuthenticationEnabledKey());
}

void WebPreferences::setWebShareFileAPIEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::webShareFileAPIEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::webShareFileAPIEnabledKey(), value);
}

bool WebPreferences::webShareFileAPIEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::webShareFileAPIEnabledKey());
}

void WebPreferences::setWebGL2Enabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::webGL2EnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::webGL2EnabledKey(), value);
}

bool WebPreferences::webGL2Enabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::webGL2EnabledKey());
}

void WebPreferences::setWebGPUEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::webGPUEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::webGPUEnabledKey(), value);
}

bool WebPreferences::webGPUEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::webGPUEnabledKey());
}

void WebPreferences::setWebRTCH264LowLatencyEncoderEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::webRTCH264LowLatencyEncoderEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::webRTCH264LowLatencyEncoderEnabledKey(), value);
}

bool WebPreferences::webRTCH264LowLatencyEncoderEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::webRTCH264LowLatencyEncoderEnabledKey());
}

void WebPreferences::setWebRTCH265CodecEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::webRTCH265CodecEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::webRTCH265CodecEnabledKey(), value);
}

bool WebPreferences::webRTCH265CodecEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::webRTCH265CodecEnabledKey());
}

void WebPreferences::setWebRTCPlatformCodecsInGPUProcessEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::webRTCPlatformCodecsInGPUProcessEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::webRTCPlatformCodecsInGPUProcessEnabledKey(), value);
}

bool WebPreferences::webRTCPlatformCodecsInGPUProcessEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::webRTCPlatformCodecsInGPUProcessEnabledKey());
}

void WebPreferences::setWebRTCVP9CodecEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::webRTCVP9CodecEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::webRTCVP9CodecEnabledKey(), value);
}

bool WebPreferences::webRTCVP9CodecEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::webRTCVP9CodecEnabledKey());
}

void WebPreferences::setWebXREnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::webXREnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::webXREnabledKey(), value);
}

bool WebPreferences::webXREnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::webXREnabledKey());
}

void WebPreferences::setRequestIdleCallbackEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::requestIdleCallbackEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::requestIdleCallbackEnabledKey(), value);
}

bool WebPreferences::requestIdleCallbackEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::requestIdleCallbackEnabledKey());
}

const Vector<RefPtr<API::Object>>& WebPreferences::experimentalFeatures()
{
    static NeverDestroyed<Vector<RefPtr<API::Object>>> features(std::initializer_list<RefPtr<API::Object>> {
        API::ExperimentalFeature::create("@page CSS at-rule support", "PageAtRuleSupportEnabled", "Enable @page support", false, false),
        API::ExperimentalFeature::create("Accessibility Object Model", "AccessibilityObjectModelEnabled", "Accessibility Object Model support", false, false),
        API::ExperimentalFeature::create("Ad Click Attribution Debug Mode", "AdClickAttributionDebugModeEnabled", "Enable Ad Click Attribution Debug Mode", false, false),
        API::ExperimentalFeature::create("Ad Click Attribution", "AdClickAttributionEnabled", "Enable Ad Click Attribution for Cross-Site Link Navigations", false, false),
        API::ExperimentalFeature::create("Aspect ratio of <img> from width and height", "AspectRatioOfImgFromWidthAndHeightEnabled", "Map HTML attributes width/height to the default aspect ratio of <img>", true, false),
        API::ExperimentalFeature::create("Async clipboard API", "AsyncClipboardAPIEnabled", "Enable the async clipboard API", DEFAULT_ASYNC_CLIPBOARD_API_ENABLED, false),
        API::ExperimentalFeature::create("Automatic HTTPS upgrade", "HTTPSUpgradeEnabled", "Automatic HTTPS upgrade for known supported sites", false, false),
        API::ExperimentalFeature::create("Blank anchor target implies rel=noopener", "BlankAnchorTargetImpliesNoOpenerEnabled", "target=_blank on anchor elements implies rel=noopener", true, false),
        API::ExperimentalFeature::create("Block top-level redirects by third-party iframes", "ThirdPartyIframeRedirectBlockingEnabled", "Block top-level redirects by third-party iframes", true, false),
        API::ExperimentalFeature::create("CSS Animations via Web Animations", "WebAnimationsCSSIntegrationEnabled", "Expose CSS Animations and CSS Transitions through getAnimations()", true, false),
        API::ExperimentalFeature::create("CSS Custom Properties and Values API", "CSSCustomPropertiesAndValuesEnabled", "Enable CSS Custom Properties and Values API", false, false),
#if ENABLE(CSS_PAINTING_API)
        API::ExperimentalFeature::create("CSS Painting API", "CSSPaintingAPIEnabled", "Enable the CSS Painting API", DEFAULT_CSS_PAINTING_API_ENABLED, false),
#endif
        API::ExperimentalFeature::create("CSS Shadow Parts", "CSSShadowPartsEnabled", "Enable CSS Shadow Parts", true, false),
        API::ExperimentalFeature::create("CSS Spring Animations", "SpringTimingFunctionEnabled", "CSS Spring Animation prototype", DEFAULT_EXPERIMENTAL_FEATURES_ENABLED, false),
#if ENABLE(CSS_TYPED_OM)
        API::ExperimentalFeature::create("CSS Typed OM", "CSSTypedOMEnabled", "Enable the CSS Typed OM", DEFAULT_CSS_TYPED_OM_ENABLED, false),
#endif
        API::ExperimentalFeature::create("CSSOM View Smooth Scrolling", "CSSOMViewSmoothScrollingEnabled", "Enable DOM API and CSS property for 'smooth' scroll behavior", false, false),
#if ENABLE(MEDIA_STREAM)
        API::ExperimentalFeature::create("Capture video in UI Process", "CaptureVideoInUIProcessEnabled", "Enable video capture in UI Process", false, false),
#endif
#if ENABLE(CORE_IMAGE_ACCELERATED_FILTER_RENDER)
        API::ExperimentalFeature::create("CoreImage-Accelerated Filter Rendering", "CoreImageAcceleratedFilterRenderEnabled", "Accelerated CSS and SVG filter rendering using CoreImage", false, false),
#endif
        API::ExperimentalFeature::create("Defer async scripts until DOMContentLoaded or first-paint", "ShouldDeferAsynchronousScriptsUntilAfterDocumentLoadOrFirstPaint", "Defer async scripts until DOMContentLoaded or first-paint", true, false),
        API::ExperimentalFeature::create("Dialog Element", "DialogElementEnabled", "Enable the Dialog Element", false, false),
        API::ExperimentalFeature::create("Disable Full 3rd-Party Cookie Blocking (ITP)", "IsThirdPartyCookieBlockingDisabled", "Disable full third-party cookie blocking when Intelligent Tracking Prevention is enabled", false, false),
        API::ExperimentalFeature::create("Disable Removal of Non-Cookie Data After 7 Days of No User Interaction (ITP)", "IsFirstPartyWebsiteDataRemovalDisabled", "Disable removal of all non-cookie website data after seven days of no user interaction when Intelligent Tracking Prevention is enabled", false, false),
        API::ExperimentalFeature::create("Disable Web SQL", "WebSQLDisabled", "Disable Web SQL", true, false),
        API::ExperimentalFeature::create("Disallow sync XHR during page dismissal", "DisallowSyncXHRDuringPageDismissalEnabled", "Disallow synchronous XMLHttpRequest during page dismissal", defaultDisallowSyncXHRDuringPageDismissalEnabled(), false),
        API::ExperimentalFeature::create("Fetch API Request KeepAlive", "FetchAPIKeepAliveEnabled", "Enable Fetch API Request KeepAlive", true, false),
#if ENABLE(VIDEO)
        API::ExperimentalFeature::create("Generic Text Track Cue API", "GenericCueAPIEnabled", "Enable Generic Text Track Cue API", true, false),
#endif
        API::ExperimentalFeature::create("HDR Media Capabilities", "HDRMediaCapabilitiesEnabled", "HDR Media Capabilities", true, false),
#if HAVE(CFNETWORK_ALTERNATIVE_SERVICE)
        API::ExperimentalFeature::create("HTTP/3", "HTTP3Enabled", "Enable HTTP/3", false, false),
#endif
        API::ExperimentalFeature::create("Highlight API", "HighlightAPIEnabled", "Highlight API support", false, false),
        API::ExperimentalFeature::create("ImageBitmap", "ImageBitmapEnabled", "Support for the ImageBitmap APIs", DEFAULT_EXPERIMENTAL_FEATURES_ENABLED, false),
        API::ExperimentalFeature::create("In-Process Cookie Cache", "InProcessCookieCacheEnabled", "In-Process DOM Cookie Cache", true, false),
#if HAVE(INCREMENTAL_PDF_APIS)
        API::ExperimentalFeature::create("Incremental PDF Loading", "IncrementalPDFLoadingEnabled", "Enable Incremental PDF Loading on supported platforms", defaultIncrementalPDFEnabled(), false),
#endif
#if ENABLE(INTERSECTION_OBSERVER)
        API::ExperimentalFeature::create("Intersection Observer", "IntersectionObserverEnabled", "Enable Intersection Observer support", true, false),
#endif
        API::ExperimentalFeature::create("IsLoggedIn web API", "IsLoggedInAPIEnabled", "Enable the proposed IsLoggedIn web API", false, false),
#if ENABLE(ACCESSIBILITY_ISOLATED_TREE)
        API::ExperimentalFeature::create("Isolated Accessibility Tree Mode", "IsAccessibilityIsolatedTreeEnabled", "Enable an accessibility hierarchy for VoiceOver that can be accessed on a secondary thread for improved performance", false, false),
#endif
        API::ExperimentalFeature::create("Lazy Image Loading", "LazyImageLoadingEnabled", "Enable Lazy Image Loading support", false, false),
        API::ExperimentalFeature::create("Link preload responsive images", "LinkPreloadResponsiveImagesEnabled", "Enable link preload responsive images", false, false),
        API::ExperimentalFeature::create("LinkPrefetch", "LinkPrefetchEnabled", "Enable LinkedPrefetch", false, false),
#if ENABLE(WEBGL) || ENABLE(WEBGL2)
        API::ExperimentalFeature::create("Mask WebGL Strings", "MaskWebGLStringsEnabled", "Mask WebGL Vendor, Renderer, Shader Language Strings", true, false),
#endif
        API::ExperimentalFeature::create("MathML Core", "CoreMathMLEnabled", "Disable features removed from the MathML Core spec.", DEFAULT_CORE_MATHML_ENABLED, false),
        API::ExperimentalFeature::create("Media Capabilities Extensions", "MediaCapabilitiesExtensionsEnabled", "Media Capabilities Extensions", true, false),
#if ENABLE(MEDIA_STREAM)
        API::ExperimentalFeature::create("MediaRecorder", "MediaRecorderEnabled", "MediaRecorder", false, false),
#endif
#if ENABLE(WEB_AUDIO)
        API::ExperimentalFeature::create("Modern WebAudio API", "ModernUnprefixedWebAudioEnabled", "Modern and unprefixed WebAudio API", false, false),
#endif
#if HAVE(NSURLSESSION_WEBSOCKET)
        API::ExperimentalFeature::create("NSURLSession WebSocket", "IsNSURLSessionWebSocketEnabled", "Use NSURLSession WebSocket API", false, false),
#endif
        API::ExperimentalFeature::create("Paint Timing", "PaintTimingEnabled", "Enable PaintTiming API", false, false),
        API::ExperimentalFeature::create("Quirk to prevent delayed initial painting on sites using Google's Anti-Flicker optimization", "GoogleAntiFlickerOptimizationQuirkEnabled", "Quirk to prevent delayed initial painting on sites using Google's Anti-Flicker optimization", true, false),
        API::ExperimentalFeature::create("ReadableByteStream", "ReadableByteStreamAPIEnabled", "Enable Readable Byte Streams", false, false),
        API::ExperimentalFeature::create("Referrer Policy attribute", "ReferrerPolicyAttributeEnabled", "Enable Referrer Policy attribute", true, false),
#if ENABLE(WIRELESS_PLAYBACK_TARGET)
        API::ExperimentalFeature::create("Remote Playback API", "RemotePlaybackEnabled", "Enable Remote Playback API", true, false),
#endif
#if ENABLE(RESIZE_OBSERVER)
        API::ExperimentalFeature::create("Resize Observer", "ResizeObserverEnabled", "Enable Resize Observer support", true, false),
#endif
        API::ExperimentalFeature::create("SameSite strict enforcement (ITP)", "IsSameSiteStrictEnforcementEnabled", "Enable SameSite strict enforcement to mitigate bounce tracking", false, false),
#if ENABLE(MEDIA_STREAM) && PLATFORM(MAC)
        API::ExperimentalFeature::create("ScreenCapture", "ScreenCaptureEnabled", "Enable ScreenCapture", true, false),
#endif
        API::ExperimentalFeature::create("Server Timing", "ServerTimingEnabled", "Enable Server Timing API", DEFAULT_SERVER_TIMING_ENABLED, false),
        API::ExperimentalFeature::create("Swap Processes on Cross-Site Navigation", "ProcessSwapOnCrossSiteNavigationEnabled", "Swap WebContent Processes on cross-site navigations", DEFAULT_PROCESS_SWAP_ON_CROSS_SITE_NAVIGATION_ENABLED, false),
        API::ExperimentalFeature::create("Synthetic Editing Commands", "SyntheticEditingCommandsEnabled", "Enable Synthetic Editing Commands", true, false),
        API::ExperimentalFeature::create("VP9 decoder", "VP9DecoderEnabled", "Enable VP9 decoder", false, false),
        API::ExperimentalFeature::create("Visual Viewport API", "VisualViewportAPIEnabled", "Enable Visual Viewport API", true, false),
        API::ExperimentalFeature::create("Web Animations composite operations", "WebAnimationsCompositeOperationsEnabled", "Support for the CompositeOperation enum and properties consuming it", DEFAULT_EXPERIMENTAL_FEATURES_ENABLED, false),
        API::ExperimentalFeature::create("Web Animations mutable timelines", "WebAnimationsMutableTimelinesEnabled", "Support for setting the timeline property of an Animation object", DEFAULT_EXPERIMENTAL_FEATURES_ENABLED, false),
        API::ExperimentalFeature::create("Web Animations", "WebAnimationsEnabled", "Web Animations prototype", true, false),
#if ENABLE(WEB_AUTHN)
        API::ExperimentalFeature::create("Web Authentication Local Authenticator", "WebAuthenticationLocalAuthenticatorEnabled", "Enable Web Authentication local authenticator support", false, false),
#endif
#if ENABLE(WEB_AUTHN)
        API::ExperimentalFeature::create("Web Authentication", "WebAuthenticationEnabled", "Enable Web Authentication support", false, false),
#endif
        API::ExperimentalFeature::create("Web Share API Level 2", "WebShareFileAPIEnabled", "Enable level 2 of Web Share API", false, false),
#if ENABLE(WEBGL2)
        API::ExperimentalFeature::create("WebGL 2.0", "WebGL2Enabled", "WebGL 2 prototype", false, false),
#endif
#if ENABLE(WEBGPU)
        API::ExperimentalFeature::create("WebGPU", "WebGPUEnabled", "WebGPU Sketch prototype", defaultWebGPUEnabled(), false),
#endif
#if ENABLE(WEB_RTC)
        API::ExperimentalFeature::create("WebRTC H264 LowLatency encoder", "WebRTCH264LowLatencyEncoderEnabled", "Enable H264 LowLatency encoder", false, false),
#endif
#if ENABLE(WEB_RTC)
        API::ExperimentalFeature::create("WebRTC H265 codec", "WebRTCH265CodecEnabled", "Enable WebRTC H265 codec", false, false),
#endif
#if ENABLE(WEB_RTC)
        API::ExperimentalFeature::create("WebRTC Platform Codecs in GPU Process", "WebRTCPlatformCodecsInGPUProcessEnabled", "Enable WebRTC Platform Codecs in GPU Process", defaultWebRTCCodecsInGPUProcess(), false),
#endif
#if ENABLE(WEB_RTC)
        API::ExperimentalFeature::create("WebRTC VP9 codec", "WebRTCVP9CodecEnabled", "Enable WebRTC VP9 codec", false, false),
#endif
#if ENABLE(WEBXR)
        API::ExperimentalFeature::create("WebXR Device API", "WebXREnabled", "Adds support for accessing virtual reality (VR) and augmented reality (AR) devices, including sensors and head-mounted displays, on the Web", defaultWebXREnabled(), false),
#endif
        API::ExperimentalFeature::create("requestIdleCallback", "RequestIdleCallbackEnabled", "Enable requestIdleCallback support", false, false),
    });

    return features;
}

bool WebPreferences::isFeatureEnabled(const API::ExperimentalFeature& feature) const
{
    struct FeatureGetterMapping {
        const char* name;
        bool (WebPreferences::*function) () const;
    };

    static FeatureGetterMapping getters[] = {
        { "PageAtRuleSupportEnabled", &WebPreferences::pageAtRuleSupportEnabled },
        { "AccessibilityObjectModelEnabled", &WebPreferences::accessibilityObjectModelEnabled },
        { "AdClickAttributionDebugModeEnabled", &WebPreferences::adClickAttributionDebugModeEnabled },
        { "AdClickAttributionEnabled", &WebPreferences::adClickAttributionEnabled },
        { "AspectRatioOfImgFromWidthAndHeightEnabled", &WebPreferences::aspectRatioOfImgFromWidthAndHeightEnabled },
        { "AsyncClipboardAPIEnabled", &WebPreferences::asyncClipboardAPIEnabled },
        { "HTTPSUpgradeEnabled", &WebPreferences::httpSUpgradeEnabled },
        { "BlankAnchorTargetImpliesNoOpenerEnabled", &WebPreferences::blankAnchorTargetImpliesNoOpenerEnabled },
        { "ThirdPartyIframeRedirectBlockingEnabled", &WebPreferences::thirdPartyIframeRedirectBlockingEnabled },
        { "WebAnimationsCSSIntegrationEnabled", &WebPreferences::webAnimationsCSSIntegrationEnabled },
        { "CSSCustomPropertiesAndValuesEnabled", &WebPreferences::cssCustomPropertiesAndValuesEnabled },
#if ENABLE(CSS_PAINTING_API)
        { "CSSPaintingAPIEnabled", &WebPreferences::cssPaintingAPIEnabled },
#endif
        { "CSSShadowPartsEnabled", &WebPreferences::cssShadowPartsEnabled },
        { "SpringTimingFunctionEnabled", &WebPreferences::springTimingFunctionEnabled },
#if ENABLE(CSS_TYPED_OM)
        { "CSSTypedOMEnabled", &WebPreferences::cssTypedOMEnabled },
#endif
        { "CSSOMViewSmoothScrollingEnabled", &WebPreferences::cssOMViewSmoothScrollingEnabled },
#if ENABLE(MEDIA_STREAM)
        { "CaptureVideoInUIProcessEnabled", &WebPreferences::captureVideoInUIProcessEnabled },
#endif
#if ENABLE(CORE_IMAGE_ACCELERATED_FILTER_RENDER)
        { "CoreImageAcceleratedFilterRenderEnabled", &WebPreferences::coreImageAcceleratedFilterRenderEnabled },
#endif
        { "ShouldDeferAsynchronousScriptsUntilAfterDocumentLoadOrFirstPaint", &WebPreferences::shouldDeferAsynchronousScriptsUntilAfterDocumentLoadOrFirstPaint },
        { "DialogElementEnabled", &WebPreferences::dialogElementEnabled },
        { "IsThirdPartyCookieBlockingDisabled", &WebPreferences::isThirdPartyCookieBlockingDisabled },
        { "IsFirstPartyWebsiteDataRemovalDisabled", &WebPreferences::isFirstPartyWebsiteDataRemovalDisabled },
        { "WebSQLDisabled", &WebPreferences::webSQLDisabled },
        { "DisallowSyncXHRDuringPageDismissalEnabled", &WebPreferences::disallowSyncXHRDuringPageDismissalEnabled },
        { "FetchAPIKeepAliveEnabled", &WebPreferences::fetchAPIKeepAliveEnabled },
#if ENABLE(VIDEO)
        { "GenericCueAPIEnabled", &WebPreferences::genericCueAPIEnabled },
#endif
        { "HDRMediaCapabilitiesEnabled", &WebPreferences::hDRMediaCapabilitiesEnabled },
#if HAVE(CFNETWORK_ALTERNATIVE_SERVICE)
        { "HTTP3Enabled", &WebPreferences::http3Enabled },
#endif
        { "HighlightAPIEnabled", &WebPreferences::highlightAPIEnabled },
        { "ImageBitmapEnabled", &WebPreferences::imageBitmapEnabled },
        { "InProcessCookieCacheEnabled", &WebPreferences::inProcessCookieCacheEnabled },
#if HAVE(INCREMENTAL_PDF_APIS)
        { "IncrementalPDFLoadingEnabled", &WebPreferences::incrementalPDFLoadingEnabled },
#endif
#if ENABLE(INTERSECTION_OBSERVER)
        { "IntersectionObserverEnabled", &WebPreferences::intersectionObserverEnabled },
#endif
        { "IsLoggedInAPIEnabled", &WebPreferences::isLoggedInAPIEnabled },
#if ENABLE(ACCESSIBILITY_ISOLATED_TREE)
        { "IsAccessibilityIsolatedTreeEnabled", &WebPreferences::isAccessibilityIsolatedTreeEnabled },
#endif
        { "LazyImageLoadingEnabled", &WebPreferences::lazyImageLoadingEnabled },
        { "LinkPreloadResponsiveImagesEnabled", &WebPreferences::linkPreloadResponsiveImagesEnabled },
        { "LinkPrefetchEnabled", &WebPreferences::linkPrefetchEnabled },
#if ENABLE(WEBGL) || ENABLE(WEBGL2)
        { "MaskWebGLStringsEnabled", &WebPreferences::maskWebGLStringsEnabled },
#endif
        { "CoreMathMLEnabled", &WebPreferences::coreMathMLEnabled },
        { "MediaCapabilitiesExtensionsEnabled", &WebPreferences::mediaCapabilitiesExtensionsEnabled },
#if ENABLE(MEDIA_STREAM)
        { "MediaRecorderEnabled", &WebPreferences::mediaRecorderEnabled },
#endif
#if ENABLE(WEB_AUDIO)
        { "ModernUnprefixedWebAudioEnabled", &WebPreferences::modernUnprefixedWebAudioEnabled },
#endif
#if HAVE(NSURLSESSION_WEBSOCKET)
        { "IsNSURLSessionWebSocketEnabled", &WebPreferences::isNSURLSessionWebSocketEnabled },
#endif
        { "PaintTimingEnabled", &WebPreferences::paintTimingEnabled },
        { "GoogleAntiFlickerOptimizationQuirkEnabled", &WebPreferences::googleAntiFlickerOptimizationQuirkEnabled },
        { "ReadableByteStreamAPIEnabled", &WebPreferences::readableByteStreamAPIEnabled },
        { "ReferrerPolicyAttributeEnabled", &WebPreferences::referrerPolicyAttributeEnabled },
#if ENABLE(WIRELESS_PLAYBACK_TARGET)
        { "RemotePlaybackEnabled", &WebPreferences::remotePlaybackEnabled },
#endif
#if ENABLE(RESIZE_OBSERVER)
        { "ResizeObserverEnabled", &WebPreferences::resizeObserverEnabled },
#endif
        { "IsSameSiteStrictEnforcementEnabled", &WebPreferences::isSameSiteStrictEnforcementEnabled },
#if ENABLE(MEDIA_STREAM) && PLATFORM(MAC)
        { "ScreenCaptureEnabled", &WebPreferences::screenCaptureEnabled },
#endif
        { "ServerTimingEnabled", &WebPreferences::serverTimingEnabled },
        { "ProcessSwapOnCrossSiteNavigationEnabled", &WebPreferences::processSwapOnCrossSiteNavigationEnabled },
        { "SyntheticEditingCommandsEnabled", &WebPreferences::syntheticEditingCommandsEnabled },
        { "VP9DecoderEnabled", &WebPreferences::vp9DecoderEnabled },
        { "VisualViewportAPIEnabled", &WebPreferences::visualViewportAPIEnabled },
        { "WebAnimationsCompositeOperationsEnabled", &WebPreferences::webAnimationsCompositeOperationsEnabled },
        { "WebAnimationsMutableTimelinesEnabled", &WebPreferences::webAnimationsMutableTimelinesEnabled },
        { "WebAnimationsEnabled", &WebPreferences::webAnimationsEnabled },
#if ENABLE(WEB_AUTHN)
        { "WebAuthenticationLocalAuthenticatorEnabled", &WebPreferences::webAuthenticationLocalAuthenticatorEnabled },
#endif
#if ENABLE(WEB_AUTHN)
        { "WebAuthenticationEnabled", &WebPreferences::webAuthenticationEnabled },
#endif
        { "WebShareFileAPIEnabled", &WebPreferences::webShareFileAPIEnabled },
#if ENABLE(WEBGL2)
        { "WebGL2Enabled", &WebPreferences::webGL2Enabled },
#endif
#if ENABLE(WEBGPU)
        { "WebGPUEnabled", &WebPreferences::webGPUEnabled },
#endif
#if ENABLE(WEB_RTC)
        { "WebRTCH264LowLatencyEncoderEnabled", &WebPreferences::webRTCH264LowLatencyEncoderEnabled },
#endif
#if ENABLE(WEB_RTC)
        { "WebRTCH265CodecEnabled", &WebPreferences::webRTCH265CodecEnabled },
#endif
#if ENABLE(WEB_RTC)
        { "WebRTCPlatformCodecsInGPUProcessEnabled", &WebPreferences::webRTCPlatformCodecsInGPUProcessEnabled },
#endif
#if ENABLE(WEB_RTC)
        { "WebRTCVP9CodecEnabled", &WebPreferences::webRTCVP9CodecEnabled },
#endif
#if ENABLE(WEBXR)
        { "WebXREnabled", &WebPreferences::webXREnabled },
#endif
        { "RequestIdleCallbackEnabled", &WebPreferences::requestIdleCallbackEnabled },
    };

    const String& key = feature.key();

    for (auto& getter : getters) {
        if (key == getter.name)
            return (this->*getter.function)();
    }

    return false;
}

void WebPreferences::setFeatureEnabled(const API::ExperimentalFeature& feature, bool value)
{
    setExperimentalFeatureEnabledForKey(feature.key(), value);
}

void WebPreferences::setExperimentalFeatureEnabledForKey(const String& key, bool value)
{
    struct FeatureSetterMapping {
        const char* name;
        void (WebPreferences::*function) (const bool&);
    };

    static FeatureSetterMapping setters[] = {
        { "PageAtRuleSupportEnabled", &WebPreferences::setPageAtRuleSupportEnabled },
        { "AccessibilityObjectModelEnabled", &WebPreferences::setAccessibilityObjectModelEnabled },
        { "AdClickAttributionDebugModeEnabled", &WebPreferences::setAdClickAttributionDebugModeEnabled },
        { "AdClickAttributionEnabled", &WebPreferences::setAdClickAttributionEnabled },
        { "AspectRatioOfImgFromWidthAndHeightEnabled", &WebPreferences::setAspectRatioOfImgFromWidthAndHeightEnabled },
        { "AsyncClipboardAPIEnabled", &WebPreferences::setAsyncClipboardAPIEnabled },
        { "HTTPSUpgradeEnabled", &WebPreferences::setHTTPSUpgradeEnabled },
        { "BlankAnchorTargetImpliesNoOpenerEnabled", &WebPreferences::setBlankAnchorTargetImpliesNoOpenerEnabled },
        { "ThirdPartyIframeRedirectBlockingEnabled", &WebPreferences::setThirdPartyIframeRedirectBlockingEnabled },
        { "WebAnimationsCSSIntegrationEnabled", &WebPreferences::setWebAnimationsCSSIntegrationEnabled },
        { "CSSCustomPropertiesAndValuesEnabled", &WebPreferences::setCSSCustomPropertiesAndValuesEnabled },
#if ENABLE(CSS_PAINTING_API)
        { "CSSPaintingAPIEnabled", &WebPreferences::setCSSPaintingAPIEnabled },
#endif
        { "CSSShadowPartsEnabled", &WebPreferences::setCSSShadowPartsEnabled },
        { "SpringTimingFunctionEnabled", &WebPreferences::setSpringTimingFunctionEnabled },
#if ENABLE(CSS_TYPED_OM)
        { "CSSTypedOMEnabled", &WebPreferences::setCSSTypedOMEnabled },
#endif
        { "CSSOMViewSmoothScrollingEnabled", &WebPreferences::setCSSOMViewSmoothScrollingEnabled },
#if ENABLE(MEDIA_STREAM)
        { "CaptureVideoInUIProcessEnabled", &WebPreferences::setCaptureVideoInUIProcessEnabled },
#endif
#if ENABLE(CORE_IMAGE_ACCELERATED_FILTER_RENDER)
        { "CoreImageAcceleratedFilterRenderEnabled", &WebPreferences::setCoreImageAcceleratedFilterRenderEnabled },
#endif
        { "ShouldDeferAsynchronousScriptsUntilAfterDocumentLoadOrFirstPaint", &WebPreferences::setShouldDeferAsynchronousScriptsUntilAfterDocumentLoadOrFirstPaint },
        { "DialogElementEnabled", &WebPreferences::setDialogElementEnabled },
        { "IsThirdPartyCookieBlockingDisabled", &WebPreferences::setIsThirdPartyCookieBlockingDisabled },
        { "IsFirstPartyWebsiteDataRemovalDisabled", &WebPreferences::setIsFirstPartyWebsiteDataRemovalDisabled },
        { "WebSQLDisabled", &WebPreferences::setWebSQLDisabled },
        { "DisallowSyncXHRDuringPageDismissalEnabled", &WebPreferences::setDisallowSyncXHRDuringPageDismissalEnabled },
        { "FetchAPIKeepAliveEnabled", &WebPreferences::setFetchAPIKeepAliveEnabled },
#if ENABLE(VIDEO)
        { "GenericCueAPIEnabled", &WebPreferences::setGenericCueAPIEnabled },
#endif
        { "HDRMediaCapabilitiesEnabled", &WebPreferences::setHDRMediaCapabilitiesEnabled },
#if HAVE(CFNETWORK_ALTERNATIVE_SERVICE)
        { "HTTP3Enabled", &WebPreferences::setHTTP3Enabled },
#endif
        { "HighlightAPIEnabled", &WebPreferences::setHighlightAPIEnabled },
        { "ImageBitmapEnabled", &WebPreferences::setImageBitmapEnabled },
        { "InProcessCookieCacheEnabled", &WebPreferences::setInProcessCookieCacheEnabled },
#if HAVE(INCREMENTAL_PDF_APIS)
        { "IncrementalPDFLoadingEnabled", &WebPreferences::setIncrementalPDFLoadingEnabled },
#endif
#if ENABLE(INTERSECTION_OBSERVER)
        { "IntersectionObserverEnabled", &WebPreferences::setIntersectionObserverEnabled },
#endif
        { "IsLoggedInAPIEnabled", &WebPreferences::setIsLoggedInAPIEnabled },
#if ENABLE(ACCESSIBILITY_ISOLATED_TREE)
        { "IsAccessibilityIsolatedTreeEnabled", &WebPreferences::setIsAccessibilityIsolatedTreeEnabled },
#endif
        { "LazyImageLoadingEnabled", &WebPreferences::setLazyImageLoadingEnabled },
        { "LinkPreloadResponsiveImagesEnabled", &WebPreferences::setLinkPreloadResponsiveImagesEnabled },
        { "LinkPrefetchEnabled", &WebPreferences::setLinkPrefetchEnabled },
#if ENABLE(WEBGL) || ENABLE(WEBGL2)
        { "MaskWebGLStringsEnabled", &WebPreferences::setMaskWebGLStringsEnabled },
#endif
        { "CoreMathMLEnabled", &WebPreferences::setCoreMathMLEnabled },
        { "MediaCapabilitiesExtensionsEnabled", &WebPreferences::setMediaCapabilitiesExtensionsEnabled },
#if ENABLE(MEDIA_STREAM)
        { "MediaRecorderEnabled", &WebPreferences::setMediaRecorderEnabled },
#endif
#if ENABLE(WEB_AUDIO)
        { "ModernUnprefixedWebAudioEnabled", &WebPreferences::setModernUnprefixedWebAudioEnabled },
#endif
#if HAVE(NSURLSESSION_WEBSOCKET)
        { "IsNSURLSessionWebSocketEnabled", &WebPreferences::setIsNSURLSessionWebSocketEnabled },
#endif
        { "PaintTimingEnabled", &WebPreferences::setPaintTimingEnabled },
        { "GoogleAntiFlickerOptimizationQuirkEnabled", &WebPreferences::setGoogleAntiFlickerOptimizationQuirkEnabled },
        { "ReadableByteStreamAPIEnabled", &WebPreferences::setReadableByteStreamAPIEnabled },
        { "ReferrerPolicyAttributeEnabled", &WebPreferences::setReferrerPolicyAttributeEnabled },
#if ENABLE(WIRELESS_PLAYBACK_TARGET)
        { "RemotePlaybackEnabled", &WebPreferences::setRemotePlaybackEnabled },
#endif
#if ENABLE(RESIZE_OBSERVER)
        { "ResizeObserverEnabled", &WebPreferences::setResizeObserverEnabled },
#endif
        { "IsSameSiteStrictEnforcementEnabled", &WebPreferences::setIsSameSiteStrictEnforcementEnabled },
#if ENABLE(MEDIA_STREAM) && PLATFORM(MAC)
        { "ScreenCaptureEnabled", &WebPreferences::setScreenCaptureEnabled },
#endif
        { "ServerTimingEnabled", &WebPreferences::setServerTimingEnabled },
        { "ProcessSwapOnCrossSiteNavigationEnabled", &WebPreferences::setProcessSwapOnCrossSiteNavigationEnabled },
        { "SyntheticEditingCommandsEnabled", &WebPreferences::setSyntheticEditingCommandsEnabled },
        { "VP9DecoderEnabled", &WebPreferences::setVP9DecoderEnabled },
        { "VisualViewportAPIEnabled", &WebPreferences::setVisualViewportAPIEnabled },
        { "WebAnimationsCompositeOperationsEnabled", &WebPreferences::setWebAnimationsCompositeOperationsEnabled },
        { "WebAnimationsMutableTimelinesEnabled", &WebPreferences::setWebAnimationsMutableTimelinesEnabled },
        { "WebAnimationsEnabled", &WebPreferences::setWebAnimationsEnabled },
#if ENABLE(WEB_AUTHN)
        { "WebAuthenticationLocalAuthenticatorEnabled", &WebPreferences::setWebAuthenticationLocalAuthenticatorEnabled },
#endif
#if ENABLE(WEB_AUTHN)
        { "WebAuthenticationEnabled", &WebPreferences::setWebAuthenticationEnabled },
#endif
        { "WebShareFileAPIEnabled", &WebPreferences::setWebShareFileAPIEnabled },
#if ENABLE(WEBGL2)
        { "WebGL2Enabled", &WebPreferences::setWebGL2Enabled },
#endif
#if ENABLE(WEBGPU)
        { "WebGPUEnabled", &WebPreferences::setWebGPUEnabled },
#endif
#if ENABLE(WEB_RTC)
        { "WebRTCH264LowLatencyEncoderEnabled", &WebPreferences::setWebRTCH264LowLatencyEncoderEnabled },
#endif
#if ENABLE(WEB_RTC)
        { "WebRTCH265CodecEnabled", &WebPreferences::setWebRTCH265CodecEnabled },
#endif
#if ENABLE(WEB_RTC)
        { "WebRTCPlatformCodecsInGPUProcessEnabled", &WebPreferences::setWebRTCPlatformCodecsInGPUProcessEnabled },
#endif
#if ENABLE(WEB_RTC)
        { "WebRTCVP9CodecEnabled", &WebPreferences::setWebRTCVP9CodecEnabled },
#endif
#if ENABLE(WEBXR)
        { "WebXREnabled", &WebPreferences::setWebXREnabled },
#endif
        { "RequestIdleCallbackEnabled", &WebPreferences::setRequestIdleCallbackEnabled },
    };

    for (auto& setter : setters) {
        if (key == setter.name) {
            (this->*setter.function)(value);
            return;
        }
    }
}

void WebPreferences::enableAllExperimentalFeatures()
{
    setPageAtRuleSupportEnabled(true);
    setAccessibilityObjectModelEnabled(true);
    setAdClickAttributionDebugModeEnabled(true);
    setAdClickAttributionEnabled(true);
    setAspectRatioOfImgFromWidthAndHeightEnabled(true);
    setAsyncClipboardAPIEnabled(true);
    setHTTPSUpgradeEnabled(true);
    setBlankAnchorTargetImpliesNoOpenerEnabled(true);
    setThirdPartyIframeRedirectBlockingEnabled(true);
    setWebAnimationsCSSIntegrationEnabled(true);
    setCSSCustomPropertiesAndValuesEnabled(true);
#if ENABLE(CSS_PAINTING_API)
    setCSSPaintingAPIEnabled(true);
#endif
    setCSSShadowPartsEnabled(true);
    setSpringTimingFunctionEnabled(true);
#if ENABLE(CSS_TYPED_OM)
    setCSSTypedOMEnabled(true);
#endif
    setCSSOMViewSmoothScrollingEnabled(true);
#if ENABLE(MEDIA_STREAM)
    setCaptureVideoInUIProcessEnabled(true);
#endif
#if ENABLE(CORE_IMAGE_ACCELERATED_FILTER_RENDER)
    setCoreImageAcceleratedFilterRenderEnabled(true);
#endif
    setShouldDeferAsynchronousScriptsUntilAfterDocumentLoadOrFirstPaint(true);
    setDialogElementEnabled(true);
    setIsThirdPartyCookieBlockingDisabled(true);
    setIsFirstPartyWebsiteDataRemovalDisabled(true);
    setWebSQLDisabled(true);
    setDisallowSyncXHRDuringPageDismissalEnabled(true);
    setFetchAPIKeepAliveEnabled(true);
#if ENABLE(VIDEO)
    setGenericCueAPIEnabled(true);
#endif
    setHDRMediaCapabilitiesEnabled(true);
#if HAVE(CFNETWORK_ALTERNATIVE_SERVICE)
    setHTTP3Enabled(true);
#endif
    setHighlightAPIEnabled(true);
    setImageBitmapEnabled(true);
    setInProcessCookieCacheEnabled(true);
#if HAVE(INCREMENTAL_PDF_APIS)
    setIncrementalPDFLoadingEnabled(true);
#endif
#if ENABLE(INTERSECTION_OBSERVER)
    setIntersectionObserverEnabled(true);
#endif
    setIsLoggedInAPIEnabled(true);
#if ENABLE(ACCESSIBILITY_ISOLATED_TREE)
    setIsAccessibilityIsolatedTreeEnabled(true);
#endif
    setLazyImageLoadingEnabled(true);
    setLinkPreloadResponsiveImagesEnabled(true);
    setLinkPrefetchEnabled(true);
#if ENABLE(WEBGL) || ENABLE(WEBGL2)
    setMaskWebGLStringsEnabled(true);
#endif
    setCoreMathMLEnabled(true);
    setMediaCapabilitiesExtensionsEnabled(true);
#if ENABLE(MEDIA_STREAM)
    setMediaRecorderEnabled(true);
#endif
#if ENABLE(WEB_AUDIO)
    setModernUnprefixedWebAudioEnabled(true);
#endif
#if HAVE(NSURLSESSION_WEBSOCKET)
    setIsNSURLSessionWebSocketEnabled(true);
#endif
    setPaintTimingEnabled(true);
    setGoogleAntiFlickerOptimizationQuirkEnabled(true);
    setReadableByteStreamAPIEnabled(true);
    setReferrerPolicyAttributeEnabled(true);
#if ENABLE(WIRELESS_PLAYBACK_TARGET)
    setRemotePlaybackEnabled(true);
#endif
#if ENABLE(RESIZE_OBSERVER)
    setResizeObserverEnabled(true);
#endif
    setIsSameSiteStrictEnforcementEnabled(true);
#if ENABLE(MEDIA_STREAM) && PLATFORM(MAC)
    setScreenCaptureEnabled(true);
#endif
    setServerTimingEnabled(true);
    setProcessSwapOnCrossSiteNavigationEnabled(true);
    setSyntheticEditingCommandsEnabled(true);
    setVP9DecoderEnabled(true);
    setVisualViewportAPIEnabled(true);
    setWebAnimationsCompositeOperationsEnabled(true);
    setWebAnimationsMutableTimelinesEnabled(true);
    setWebAnimationsEnabled(true);
#if ENABLE(WEB_AUTHN)
    setWebAuthenticationLocalAuthenticatorEnabled(true);
#endif
#if ENABLE(WEB_AUTHN)
    setWebAuthenticationEnabled(true);
#endif
    setWebShareFileAPIEnabled(true);
#if ENABLE(WEBGL2)
    setWebGL2Enabled(true);
#endif
#if ENABLE(WEBGPU)
    setWebGPUEnabled(true);
#endif
#if ENABLE(WEB_RTC)
    setWebRTCH264LowLatencyEncoderEnabled(true);
#endif
#if ENABLE(WEB_RTC)
    setWebRTCH265CodecEnabled(true);
#endif
#if ENABLE(WEB_RTC)
    setWebRTCPlatformCodecsInGPUProcessEnabled(true);
#endif
#if ENABLE(WEB_RTC)
    setWebRTCVP9CodecEnabled(true);
#endif
#if ENABLE(WEBXR)
    setWebXREnabled(true);
#endif
    setRequestIdleCallbackEnabled(true);
}

}
